# 変数xに11を代入
x <- 11



y <- 33
x + y
x - y
x * y
x / y
3 * (x + 2) * y



#「5の二乗」・「5を2で割った商」・「5を2で割った余り」を計算
x <- 5
x^2
x%/%2
x%%2



# 「こんにちは、R言語」という文字列を変数aに代入し、その内容を表示
a <- "こんにちは、R言語"
print(a)



# 適当な数値を持つ変数x作成
x <- 10.0
# 平方根・logの計算
sqrt(x)
log(x)



# 適当な文字列変数a,bを用意
a <- "こんにちは"
b <- "R言語"
# paste関数によりセパレーター"！"で文字列を結合
paste(a, b, sep="！")



# 関数fを定義
f <- function(x)
{
  x + 10
}
# 関数fを実行。引数として10, 3を指定
f(10)
f(3)



# xの値に10を加える関数を定義し、その場でx=7として実行
(function(x){x+10})(7)



# 作業フォルダをC:\Temp\FinAnalysis1へと変更する
setwd("C:\\Temp\\FinAnalysis1")
# 上に同じ
setwd("C:/Temp/FinAnalysis1")



getwd()


# 1という数値のデータ型をtypeof関数で調べる
typeof(1)
# "R"という文字のデータ型をtypeof関数で調べる
typeof("R")



x <- 3 #変数xに3を代入
# xと3が等しい(TRUE)か否か(FALSE)
x == 3
# 1と3が等しくない(TRUE)か否か(FALSE)
x != 3
# xが7より大きい(TRUE)か否か(FALSE)
x > 7
# xが7より小さい(TRUE)か否か(FALSE)
x < 7
# xが3以上(TRUE)か否か(FALSE)
x >= 3
# xが3以下(TRUE)か否か(FALSE)
x <= 3



#TRUE・FALSEを反転させる
!TRUE
!FALSE



# 論理値を作成
x1 <- FALSE
y1 <- TRUE
# x1,y1の論理和(OR)を計算
x1 | y1
x1 || y1
# x1, y1論理積(AND)を計算
x1 & y1
x1 && y1



# 論理値のベクトル（後述）を作成
x2 <- c(FALSE, FALSE)
y2 <- c(TRUE, FALSE)
# x,yのベクトルの要素毎に論理和(OR)を計算
x2 | y2
# x,yのベクトルの最初の要素のみ、論理和(OR)を計算
x2 || y2
# x,yのベクトルの要素毎に論理積(AND)を計算
x2 & y2
# x,yのベクトルの最初の要素のみ、論理積(AND)を計算
x2 && y2



# 1,2,3,4,5という数値をベクトルとしてxに代入
x <- 1:5
x



# 1,10,100,1000,10000という5つの数値をベクトルyに代入
y <- c(1,10,100,1000,10000)
y



# 3を7つもつベクトルを返却
rep(3, 7)



# xの3番目の要素を抽出
x[3]
# yの2番目以外の要素を抽出
y[-2]



# xの2~4番目の要素を抽出
x[2:4]
# yの1・3番目以外の要素を抽出
y[-c(1,3)]



#x,yの要素数を取得
length(x)
length(y)
#x,yの最終要素の値を取得
x[length(x)]
y[length(y)]



#初め/終わりの部分抽出 デフォルトでは5要素
head(x)
tail(x)
#n引数を明示的に書くことで、取得数を指定することができる。
#n=1とすることで、始まり/終わりの1要素を取得することもできる
head(x,n=1)
tail(x,n=1)
#ベクトルの順序の反転
rev(x)



# 標準正規乱数を5個生成
x <- rnorm(5)
x



# 平均3・標準偏差10をもつ正規分布から7個の乱数を取得する
rnorm(7, mean=3, sd=10)



# xの値を再確認
x
# 乱数の値が0.3以上か否か
x > 0.3



# 5個の乱数のうち、いずれか1つが0.3以上か否か
any(x > 0.3)
# 5個の乱数のうち、全てが0.3以上か否か
all(x > 0.3)
# 5個の乱数のうち、0.3以上となるようなxの添え字
which(x > 0.3)



# 0.3以上となる添え字をindex変数に代入し、その添え字箇所のベクトルを取得
index <- which(x > 0.3)
x[index]



x[x > 0.3]



# 論理型ベクトル(長さ2)
too.short <- c(TRUE,FALSE)
# 論理型ベクトル(長さ7)
too.long <- c(TRUE,FALSE,TRUE,FALSE,TRUE,TRUE,TRUE)
# それぞれを、長さ5のベクトルに適用
x[too.short]
x[too.long]



# 指定したベクトル(1:9)を3行(3列)の行列データへと変換
# x <- matrix(1:9, nrow=3, ncol=3)
# と書いても可
x <- matrix(1:9, nrow=3)
x



# 行を優先してデータを代入する
x <- matrix(1:9, nrow=3, byrow=TRUE)
x
# 列を優先してデータを代入した後、t関数で転値させる
x <- matrix(1:9, nrow=3)
t(x)



# xの2行3列目を取得
x[2,3]
# xの3列目の1~3行目を取得(ベクトル)
x[1:3,3]



# xの3列目の1~3行目を取得(行列のまま)
x[1:3,3, drop=FALSE]



# xの1行目を取得(列は明示的に指定しない)
x[1,]



# xの対角成分を取得(ベクトル)
diag(x)
# 上三角行列の要素(対角成分を含む)(ベクトル)
x[upper.tri(x,diag=TRUE)]
# 下三角行列の要素(対角成分を含まない)(ベクトル)
x[lower.tri(x,diag=FALSE)]



# サンプル行列を作成
x <- matrix(c(1.0,0.5,0.5,1.0),nrow=2)
y <- matrix(c(1.0,2.0,3.0,4.0),nrow=2)



# 行列の"各要素間"の四則演算
x + y
x - y
x * y
x / y
# 行列の積
x %*% y



# 逆行列
solve(x)
# 行列式 
det(x)
# コレスキー分解
chol(x)
# 特異値分解
svd(x)
# 固有値分解 
eigen(x)



# 3行4列の0行列
zero <- matrix(0, nrow=3, ncol=4)
zero
# 4行4列の単位行列(diag(nrow=4,ncol=4)も同じ)
unit <- diag(4)
unit



port <- matrix(c(100,120,115,230,220,170,310, 330, 330), ncol=3)
port



#各時点(行)でのポートフォリオ価値
port.value <- rowSums(port)
port.value



#ポートフォリオウェイトへ変換
weight <- port/rowSums(port)
weight



rowSums(weight)



# 列名(銘柄名)としてA,B,Cと名付ける
colnames(weight) <- c("A", "B", "C") 
# 行名(日付)として2013年3月3~5日を設定
rownames(weight) <- c("2013/03/03", "2013/03/04", "2013/03/05") 
weight



# as.Date関数で文字列を日付型に変換することができる
date <- as.Date("2013/03/03")
# class関数でどのような"オブジェクト"なのかを取得できる
class(date)
# 行名としてDate型の変数を代入
rownames(weight) <- as.Date(c("2013/03/03", "2013/03/04", "2013/03/05"))
# 結果を表示するも、行名は数値に置換されている
weight



rownames(weight) <- c("2013/03/03", "2013/03/04", "2013/03/05") 



# 銘柄Dを新たな列方向の要素として追加
# Dは新たな列の列名として用いられる
weight <- cbind(weight, D=rep(0.1,3))
# 銘柄Dが加わったことによるウェイトの再調整
weight <- weight/rowSums(weight)
# 2013年3月6日のデータを追加（全銘柄20%)
# 2013/03/06が行名として扱われる 
weight <- rbind(weight, '2013/03/06'=rep(0.2,4))
weight



# weightの行数を取得
nrow(weight)
# weightの列数を取得
ncol(weight)



dim(weight)



# ベクトルのサイズ取得、10という結果を期待してnrow関数を適用
nrow(1:10)



# ベクトルのサイズ取得
NROW(1:10)
# 当然length関数で取得したサイズと同様になる
length(1:10)
# weightの行数を取得
NROW(weight)



# head関数によりirisデータの一部を表示
head(iris)
# irisデータの型を確認
class(iris)



# EuStockMarketsをデータフレーム型に変換したものをeu.stock.marketsとする
eu.stock.markets <- as.data.frame(EuStockMarkets)
class(eu.stock.markets)



# データの最初の6行を表示
head(eu.stock.markets)



# 3行目のデータを取得
eu.stock.markets[3, ]
# 1~2列目の2~7行目のデータを取得
eu.stock.markets[2:7, 1:2]



# 列名の取得
colnames(eu.stock.markets)


## # 行名の取得
rownames(eu.stock.markets)


# 後ほど列名を戻すために現在の列名を保存しておく
old.col.names <- colnames(eu.stock.markets)
# 列名の変更
colnames(eu.stock.markets) <- c("A", "B", "C", "D")
# 変更した結果の出力
colnames(eu.stock.markets)
# 列名を元に戻して出力
colnames(eu.stock.markets) <- old.col.names
colnames(eu.stock.markets)



# eu.stock.marketsデータの"CAC"列の1~5番目のデータ
eu.stock.markets$CAC[1:5]



# eu.stock.marketsの初めの3行を表示
head(eu.stock.markets, n=3)
# eu.stock.marketsの最後の3行を表示
tail(eu.stock.markets, n=3)



# summary関数によるeu.stock.marketsの要約統計量表示
summary(eu.stock.markets)



# 1列目に列名ID, 2列目に列名NAMEを指定`
x <- data.frame(ID=1:3, NAME=c("A", "B", "C"))
x



# xの構造を確認，NAME列には"Factor"と表示される
str(x)



# 先ほどの同様のデータを作成
x <- data.frame(ID=1:3, NAME=c("A", "B", "C"), stringsAsFactors=FALSE)
x



str(x)



# データフレームxに1行追加、{ID=4,NAME=D}と指定
rbind(x, c(4, "D"))
# 複数行同時に追加することも可能。
# 列名を正しく指定する必要がある点に注意
rbind(x, data.frame(ID=5:6, NAME=c("E","F")))
# データフレームxに1列追加(列名指定なし）
cbind(x, 11:13)
# データフレームxに1列追加(列名:VALと指定）
cbind(x, data.frame(VAL=11:13))



# $演算子を用いて1列追加(列名:VALと指定、列名指定必須）
x$VAL <- 11:13
x



#VAL列の各値に、同じ行のID列の値をかけて、新しい列(列名:VAL.TIMES.ID)を追加する
transform(x, VAL.TIMES.ID=VAL*ID)



## # 現在の日付を取得
date <- Sys.Date()


# Date型であることを確認
class(date)



# 適当な日付(st1art1.d, st1art2.d, end.d)を生成
# as.Date関数は、文字列("YYYY-MM-DD")をR言語内のDate型へと変換する
start1.d <- as.Date("2013-1-5")
start2.d <- as.Date("2013-1-4")
end.d   <- as.Date("2013-1-11")



# seq.Date関数を用いた連続した日付データの作成
#start1.d(2013/1/5)からend.d(2013/1/11)までの1日毎の日付
seq.Date(start1.d, end.d, by=1)
#start2.d(2013/1/4)からend.d(2013/1/11)までの3日毎の日付
seq.Date(start2.d, end.d, by=3)



# 適当な株価データstock1とstock2を作成
stock1 <- data.frame(Date=seq.Date(start1.d, end.d, by=1), A=100:106, B=1005:1011)
stock2 <- data.frame(Date=seq.Date(start2.d, end.d, by=3), C=200:202)
stock1
stock2
str(stock1)
str(stock2)



# stock1とstock2を結合
merge(stock1,stock2)



# Date列を結合キーとして，stock1とstock2を結合
# merge(stock1,stock2,by.x="Date",by.y="Date")も同様の結果になる
merge(stock1,stock2,by="Date")



# stock1とstock2を結合、ただしstock1の全データ行を保持
merge(stock1,stock2, all.x=TRUE)
# stock1とstock2を結合、ただしstock2の全データ行を保持
merge(stock1,stock2, all.y=TRUE)
# stock1とstock2を結合、ただしstock1,stock2の全データ行を保持
# merge(stock1,stock2, all.x=TRUE, all.y=TRUE)も同様の結果になる
merge(stock1,stock2, all=TRUE)



# 適当な行列xの固有値・固有ベクトルを計算
x <- matrix(1:4,nrow=2)
x.eig <- eigen(x)
x.eig
# class関数でどのデータ構造になっているのかを確認
class(x.eig)
# str関数でリストの構造を確認
str(x.eig)



# x.eigの要素数を取得
length(x.eig)



# リストの第一要素を[]演算子で取得
x.eig[1]
class(x.eig[1])



# リストの第一要素を[[]]演算子で取得
x.eig[[1]]
class(x.eig[[1]])



# リストの名前を抽出
names(x.eig)



# リストの要素に名前でアクセス([[ ]]演算子)
x.eig["values"]
# リストの要素に名前でアクセス($演算子)
x.eig$values



# 要素にID, 2要素にvalueを指定
x <- list(ID=c("A", "B"), value=100:110)
x



#xの値に応じて処理を切り分ける
x <- 3
if(x > 10){
  print("Xは10より大きい")  
}else{
  print("Xは10以下")    
}



x <- 3
# xが10より大きいか否かに応じて返却される文字列を制御する
a <- if(x > 10){
  "xは10より大きい"
}else{
  temp <- 100 * 100
  y <- "xは10以下"
  temp <- temp - 1
  y
}
a



x <- 3
a <- if(x >= 10){
  "Xは10以上"
}else if(x >= 5){
  "Xは5以上"
}else if(x >= 2){
  "Xは2以上"
}else{
  "Xは2より小さい"
}
a



# 1から10までの和の計算
sum <- 0
for (i in 1:10) {
  sum <- sum + i
}
sum



# 同様の処理をsum関数にて計算
sum(1:10)



# 1から10までの和の計算
i <- 1
sum <- 0
while(i <= 10){
  sum <- sum + i
  i <- i + 1
}
sum



# 1から10までの和の計算
i <- 1
sum <- 0
repeat{
  if(i <= 10){
    sum <- sum + i
    i <- i + 1
  }else{break}
}
sum



# 1~9までの要素をもつ行列(テストデータ)
x <- matrix(1:9, nrow=3, ncol=3)
x
# rowSums、及びapply関数による結果の比較
# rowSums関数による結果
rowSums(x)
# apply関数による結果
apply(x, 1, sum)



# 無名関数を用いてrowSums関数と同様の結果を得る
apply(x, 1, function(y){sum(y)})



# 行列xの各行の和を各行の平均値で割った値を計算
apply(x, 1, function(y){sum(y)/mean(y)})



# 平均値が1~5の正規分布に従う乱数を3個ずつ取得
x <- 1:5
lapply(x, function(i){rnorm(3, mean=i)})



# 平均値が1~5の正規分布に従う乱数を3個ずつ取得
sapply(x, function(i){rnorm(3, mean=i)})



# 平均値が1~5の正規分布に従う乱数を1個ずつ取得
sapply(x, function(i){rnorm(1, mean=i)})



# EmployedのGNP.deflatorによる回帰分析
longley.lm <- lm(longley[,7]~longley[,1])



#結果は回帰分析専用のlmクラスのオブジェクトとして返却される
class(longley.lm)
#回帰分析の結果を要約して表示
summary(longley.lm)



# summary関数を使用することで取得可能なものの一覧表示
longley.ls <- summary(longley.lm)
names(longley.ls)



# 列名を使用してモデル式を作成
longley.lm <- lm(Employed~GNP.deflator, data=longley)



# 7列目のデータ(就業者数)をその他の列の変数で回帰
longley.lms <- lapply(1:6, function(i){lm(longley[,7]~longley[,i])})



# for分を用いて同様の処理を記述
# 空のリストを作成し、そこに順次要素を追加していく
longley.lms <- list()
for(i in 1:6){
  longley.lms[[i]] <- lm(longley[,7]~longley[,i])
}



# longley.lmsの1番目の結果の決定係数を取得
summary(longley.lms[[1]])$r.squared



# 各回帰分析の結果から決定係数(R^2)を取得
sapply(longley.lms, function(x)summary(x)$r.squared)



# for分を使って上記のsapplyと同様の処理を記述
r.squared <- numeric(length(longley.lms))
for(i in 1:length(longley.lms)){
  r.squared[i] <- summary(longley.lms[[i]])$r.squared
}
r.squared



## #ggplot2のインストール
install.packages("ggplot2")


# 現在のCRANミラーサイトを確認
getOption("repos")




## # CRANのミラーサイトを変更する
chooseCRANmirror()



## # ライブラリを読み込む
library(ggplot2)



# mtcarsというデータフレームのmpg列とwt列の散布図を作成
qplot(mpg, wt, data = mtcars)



## #パッケージのヘルプの読込
help(package="ggplot2")
#qplot関数のHELPを開く
?qplot
#qplotという文字列に関する情報を検索して結果を出力
??qplot



## # port_data.csvをデータフレームとして読み込む
port.data <- read.csv("port_data.csv",stringsAsFactors=FALSE)
port.data


# port.dataの中身の確認
str(port.data)



# ファイルをport_data_write.csvとして、現在の作業フォルダに保存する
write.csv(port.data, "port_data_write.csv")



# port_data_write.csvの中身をコンソールに表示
read.csv("port_data_write.csv")



# 行番号を出力しないように保存＆再表示
write.csv(port.data, "port_data_write.csv", row.names=FALSE)
read.csv("port_data_write.csv")




# market_data.csvをデータフレームとして読み込む
market.data <- read.csv("port_data.csv",stringsAsFactors=FALSE)
market.data



#各列の確認
str(market.data)



# gsub関数により#N/AをNAへと置換する
market.data2 <- gsub("#N/A", NA, as.matrix(market.data))
market.data2



# 文字列のデータを数値型へと変換
apply(market.data2, 2, as.numeric)



#XLConnectパッケージのインストールと読込み
install.packages("XLConnect")
library(XLConnect)



#irisの一部を表示。構造の確認
head(iris)
str(iris)



#sample.xlsというファイルを現在の作業フォルダに作成
work.book <- loadWorkbook("sample.xls", create=TRUE)



#Rに組み込まれているirisデータを"iris"シートとして出力
work.book["iris"] <- iris



#作成したファイルを保存
saveWorkbook(work.book)



sample.book <- loadWorkbook("sample.xls")



sample.book["iris"]


#irisデータのうちSpecies列の値がvirginicaのものをiris2シートの5行1列目から貼り付け
sample.book["iris2", startRow=5, startCol=1] <- subset(iris, Species=="virginica")



#carsのデータをcarシートのA1セルに貼り付け、データ全体にcarsという名前を設定する
sample.book[["cars", "car!$A$1"]] <- cars



saveWorkbook(sample.book, "sample2.xls")



install.packages("xts")
# xtsライブラリのロード
## library(xts)



#sample_matrixデータの読込
data(sample_matrix)



#データの確認
class(sample_matrix)
str(sample_matrix)



#xtsクラスのオブジェクトへ変更 
sample.xts <- as.xts(sample_matrix)



# xt型のデータに正しく変換されているか確認
class(sample.xts)
str(sample.xts)



#最初の1データを確認
first(sample.xts)
#最後の1データを確認
last(sample.xts)



#最初の4日間(2007年1月2~5日)
first(sample.xts, '4 days')
#最後の1週間
last(sample.xts, '1 week')



#最初の4日間(2007年1月2~5日)以外のデータ
first(sample.xts, '-4 days')


#最後の1週間以外のデータ
last(sample.xts, '-1 week')




#2007年3月3日のデータを取得
sample.xts['2007-03-03'] 



#2007年3月のデータを取得
sample.xts['2007-03']



#2007年3月1日～2007年4月15日のデータ取得
sample.xts['2007-03-01/2007-04-15']




#2007年5月10日以降```
sample.xts['2007-05-10::']



#データ本体のみを取得
coredata(sample.xts)





#時間部分を取得
index(sample.xts)




#sample_matrixの行名を表示し、その型が文字であることを確認
rownames(sample_matrix)



class(rownames(sample_matrix))



#5行2列の適当な行列を作成
x.mat <- matrix(1:10,nrow=5)
#2013/1/1～5までの日付型を作成、文字列型へ変更し、それをx.matの行名へ。
rownames(x.mat) <- as.character(as.Date("2012-12-31")+1:5)
#matrix型であることを確認
class(x.mat)
x.mat



#xts型へ変更
x.xts <- as.xts(x.mat)
class(x.xts)
x.xts



#PriceA, PriceB列を持つデータフレームを作成
x.df <- data.frame(PriceA=c(100,101,98), PriceB=c(200,210,217))
#2013/1/1～3までの日付型を作成、文字列型へ変更し、それをx.dfの行名へ。
rownames(x.df) <- as.character(as.Date("2012-12-31")+1:3)
#xts型へ変更
x.xts <- as.xts(x.df)
class(x.xts)
x.xts



#xts型のデータを作成する
x <- xts(1:5, order.by=as.Date("2012-12-31")+0:4)
class(x)
x



#xts型のデータを作成する
x.xts <- xts(x.df, order.by=as.Date("2012-12-31")+1:3)
class(x.xts)
x.xts



# 先ほど作成したx.xtsデータの周期を計算
x.period <- periodicity(x.xts)
x.period



# x.periodの型を確認
class(x.period)



# x.period変数の周期を文字列として取得
x.period$scale



# xts型のデータ作成
x <- xts(1:6, order.by=as.Date("2012-12-31")+0:5)
# xに対し、幅3のローリング処理を適用し、各数値の組の和を計算
rollapply(x, 3, sum)



# 独立な正規分布に従う、2系列を持つ100日分のxts型のサンプルデータを作成
x <- xts(matrix(rnorm(200),ncol=2), order.by=as.Date("2012-12-31")+0:99)
# 系列名としてA, B と指定 
colnames(x) <- c("A", "B")


# 各日における推定に対して何個(この場合"日")分のデータを使うのか
width <- 30
# ローリング相関を各計測日において直近30日分のデータから算出
cor.xts <- rollapply(x, width, function(z)cor(z[,1], z[,2]), by.column=FALSE)
tail(cor.xts, 10)



# ローリング相関係数の時系列を描画
plot(cor.xts)